/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// SelfSubscriptionType the model 'SelfSubscriptionType'
type SelfSubscriptionType string

// List of SelfSubscriptionType
const (
	SELFSUBSCRIPTIONTYPE_CLOSED     SelfSubscriptionType = "Closed"
	SELFSUBSCRIPTIONTYPE_OPEN       SelfSubscriptionType = "Open"
	SELFSUBSCRIPTIONTYPE_CERN_USERS SelfSubscriptionType = "CernUsers"
)

// All allowed values of SelfSubscriptionType enum
var AllowedSelfSubscriptionTypeEnumValues = []SelfSubscriptionType{
	"Closed",
	"Open",
	"CernUsers",
}

func (v *SelfSubscriptionType) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := SelfSubscriptionType(value)
	for _, existing := range AllowedSelfSubscriptionTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid SelfSubscriptionType", value)
}

// NewSelfSubscriptionTypeFromValue returns a pointer to a valid SelfSubscriptionType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewSelfSubscriptionTypeFromValue(v string) (*SelfSubscriptionType, error) {
	ev := SelfSubscriptionType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for SelfSubscriptionType: valid values are %v", v, AllowedSelfSubscriptionTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v SelfSubscriptionType) IsValid() bool {
	for _, existing := range AllowedSelfSubscriptionTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to SelfSubscriptionType value
func (v SelfSubscriptionType) Ptr() *SelfSubscriptionType {
	return &v
}

type NullableSelfSubscriptionType struct {
	value *SelfSubscriptionType
	isSet bool
}

func (v NullableSelfSubscriptionType) Get() *SelfSubscriptionType {
	return v.value
}

func (v *NullableSelfSubscriptionType) Set(val *SelfSubscriptionType) {
	v.value = val
	v.isSet = true
}

func (v NullableSelfSubscriptionType) IsSet() bool {
	return v.isSet
}

func (v *NullableSelfSubscriptionType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSelfSubscriptionType(val *SelfSubscriptionType) *NullableSelfSubscriptionType {
	return &NullableSelfSubscriptionType{value: val, isSet: true}
}

func (v NullableSelfSubscriptionType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSelfSubscriptionType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
